% SAR - LEZ SVM for object recognition
% lezioni ispirate a http://www.vlfeat.org/applications/caltech-101-code.html
% Gli esercizi funzionano dopo aver installato il toolbox vlfeat-0.9.18 (e aver seguito il readme di installazione) e
% aver linkato correttamente il codice sottostante


clear all;
clc;
close all

dire = 'H:\MATLAB\vlfeat-0.9.18\'
% addpath to the libsvm toolbox
eval(['run ',dire,'toolbox\vl_setup'])
eval(['cd ',dire,'\apps'])


% 1) eseguire il semplice BoW + SVM visto a lezione 
% phow_caltech101();

% 2) aumentare la cardinalita' dei quadranti dello spatial histogram,
% provando varie iterazioni per ogni configurazione di parametri,
% calcolando la accuratezza media
% num_rounds = 5;
% num_words = 300;
% num_class = 7;
% sect = [1,2,3,4,5,10,20];
% cont = 0;
% 
% for sqr_num_sec = [sect]
%     cont = cont +1;
%     for i=1:num_rounds
%         
%         accu(cont,i)=phow_caltech101es2_3(num_words,sqr_num_sec,num_class);
%     end
% end

% 3) Come l'esercizio 2, variando in questo caso il numero di parole, fissando lo spatial histogram

% num_rounds = 5;
% sqr_num_sec = 3;
% num_class = 7;
% num_words = [10,20,50,100,200,1000,2000];
% cont = 0;
% 
% for sqr_num_sec = [sect]
%     cont = cont +1;
%     for i=1:num_rounds
%         
%         accu(cont,i)=phow_caltech101es2_3(num_words,sqr_num_sec,num_class);
%     end
% end


% 4) Capire qual'e' la classe pi difficile e le immagini sbagliate

% num_rounds = 1;
% sqr_num_sec = 3;
% num_class = 7;
% num_words = 300;
% cont = 0;
% 
% [accu,assign]=phow_caltech101es4(num_words,sqr_num_sec,num_class);


% 5) visualizzare le visual words; per capire cosa siano le sift, si
% guardi http://docs.opencv.org/trunk/doc/py_tutorials/py_feature2d/py_sift_intro/py_sift_intro.html
%    PASSI:
%    
%    a) capire dove sono estratte nell'immagine le features salienti (SIFT)
%    b) capire qual'e' la grandezza del supporto spaziale (patch) che viene 
%     descritta dalla feature
%    c) capire, data una particolare feature, a che visual words essa faccia riferimento
%    d) prendere tutte le visual words (ovvero tutte la patch corrispondenti
%     ad una particolare visual word) di tutte le immagini usate come training,
%     e mediarle (una volta avendole trasformate in livelli di grigio)
%    e) costruire un collage di tutte le rappresentazioni di parole visuali cosi' 
%     calcolate 

num_rounds = 1;
sqr_num_sec = 3;
num_class = 7;
num_words = 300;
cont = 0;
phow_caltech101es5(num_words,sqr_num_sec,num_class) % visualizza le codewords 



%  phow_caltech101MARCOcsBoW() % utilizza un vocabolario specifico per classe (Es 4 sotto)
% phow_caltech101MARCOpLSA() % Applica pLSA
% phow_caltech101MARCO();








% ESERCIZIO 1 - 2015
% Visualizzare su un'immagine presa a caso del dataset di training 
% le parole visuali, sotto forma di patch colorate (un colore per ogni 
% visual word) oppure di patch numerate. Questa operazione risulta
% istruttiva specialmente nel caso di poche parole visuali (per esempio, 10)

% ESERCIZIO 2 - 2015
% Data un'immagine di training, visualizzarla sotto forma di mosaico di patch,
% dove ogni patch  la patch media corrispondente alla parola visuale che si 
% trova in quella locazione dell'immagine (ricordo che il codice per la visualizzazione
% delle patch medie  gi presente nelle funzioni scaricabili dalla rete)

% ESERCIZIO 3 - 2015... copia dalla foto

% conti = 0;
% words=[10,50,100,200,500,1000,2000,3000];
% sect=[1,3,4,5];
% for i=words
%     conti = conti+1;
%     contj = 0;
%     for j=sect
%         contj = contj+1;
%         fprintf('words %i\n',i)
%         
%         num_words = i;%100;
%         num_sectx = j;
%         num_secty = j;
%         
%         [accu(conti, contj)] = phow_caltech101_speed(num_words,num_sectx,num_secty)
%         %     eval(['cd ',dire,'\apps\data'])
%     end
% end
%save accu accu, words

